var g_oCurrentRequestDebugs = [];

// SL2 uses SendTinCanRequest. SL3 uses SendTinCanStatement.
var OriginalSendTinCanStatement = (typeof SendTinCanRequest !== 'undefined') ? SendTinCanRequest : SendTinCanStatement;

SendTinCanRequest = SendTinCanStatement = function(nMessageType, strMethod, strData, strUrl, arrHeaders)
{
	var strDataFixed = unescape(strData);
	strDataFixed = unescape(strDataFixed);
	
	var arrEquals = [];
	var regex = /=/gi;
	var result;
	while ( (result = regex.exec(strDataFixed)) ) 
	{
		arrEquals.push(result.index);
	}

	var arrAmps = [-1];
	regex = /&/gi;
	while ( (result = regex.exec(strDataFixed)) ) 
	{
		arrAmps.push(result.index);
	}
	
	var equalInc = 0;
	var strNewData = "";
	
	for (var i = 0;  i < arrAmps.length; ++i)
	{
		var amp = arrAmps[i] + 1;
		var equal = arrEquals[i + equalInc];
		while (amp > equal)
		{
			++equalInc;
			equal = arrEquals[i + equalInc];
		}
		
		var key = strDataFixed.substring(amp, equal);
		var value = strDataFixed.substring(equal + 1, arrAmps[i + 1]);
		strNewData += key + '":"'  + value + '","';
	}
	
	strNewData = '{"' + strNewData.substring(0, strNewData.length - 3) + '"}';
	strNewData = strNewData.replace(/"{/gi, '{');
	strNewData = strNewData.replace(/}"/gi, '}');
	
	var data = JSON.parse(strNewData);
	
	var oTinCanRequestCopy = {};
	oTinCanRequestCopy.MessageType = nMessageType;
	oTinCanRequestCopy.Method = strMethod;
	oTinCanRequestCopy.Data = data;
	oTinCanRequestCopy.Url = strUrl;
	oTinCanRequestCopy.Headers = arrHeaders;
	
	g_oCurrentRequestDebugs.push(oTinCanRequestCopy);

	OriginalSendTinCanStatement(nMessageType, strMethod, strData, strUrl, arrHeaders);
};

var OriginalOnSendComplete = OnSendComplete;

OnSendComplete = function(commObj)
{
	var oCommObjCopy = {};
	oCommObjCopy.MessageType = commObj.MessageType || "";
	oCommObjCopy.responseText = commObj.responseText || "";
	oCommObjCopy.status = commObj.status || "";
	oCommObjCopy.statusText = commObj.statusText || "";
	oCommObjCopy.contentType = commObj.contentType || "";
	oCommObjCopy.timeout = commObj.timeout || "";

	var oDebug = {
		Request: g_oCurrentRequestDebugs.shift(),
		Response: oCommObjCopy
	};

	WriteToDebug(oDebug);

	OriginalOnSendComplete(commObj);
};

var OriginalOnSendError = OnSendError;

OnSendError = function(commObj)
{
	var oCommObjCopy = {};
	oCommObjCopy.MessageType = commObj.MessageType || "";
	oCommObjCopy.responseText = commObj.responseText || "";
	oCommObjCopy.status = commObj.status || "";
	oCommObjCopy.statusText = commObj.statusText || "";
	oCommObjCopy.contentType = commObj.contentType || "";
	oCommObjCopy.timeout = commObj.timeout || "";

	var oDebug = {
		Request: g_oCurrentRequestDebugs.shift()
	};

	var bIsError = oCommObjCopy.MessageType != 2 || oCommObjCopy.status != 404;
	var strResponseLabel = (bIsError) ? "ERROR" : "Response";
	oDebug[strResponseLabel] = oCommObjCopy;
	
	WriteToDebug(oDebug);

	OriginalOnSendError(commObj);
};


var winDebug = null;
var bWinCreated = false;

function WriteToDebug(strInfo)
{
	if (!bWinCreated)
	{
		if (!winDebug)
		{
			ShowDebugWindow();
		}
		
		var postDebug = function()
		{
			winDebug.WriteToDebug(strInfo);
			bWinCreated = true;
		};
		
		if (winDebug.addEventListener)
		{
			winDebug.addEventListener('load', postDebug, false); 
		} else if (winDebug.attachEvent)
		{
			winDebug.attachEvent('onload', postDebug);
		}
	}
	else
	{
		winDebug.WriteToDebug(strInfo);
	}
}

function ShowDebugWindow()
{
	winDebug = window.open("debug/debug.html", "Debug", "width=800,height=600,resizable,scrollbars");
	winDebug.focus();
	
	window.addEventListener("unload", function()
	{
		if (winDebug && !winDebug.closed){
			winDebug.close();
		}
	}, true);
}